<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: src/core/common/timer.hpp Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="../../annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../files.html"><span>File&#160;List</span></a></li>
      <li><a href="../../globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('df/d05/timer_8hpp_source.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">timer.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../df/d05/timer_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> *  Copyright (c) 2016, The OpenThread Authors.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *  All rights reserved.</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *  Redistribution and use in source and binary forms, with or without</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *  modification, are permitted provided that the following conditions are met:</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *  1. Redistributions of source code must retain the above copyright</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer.</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *  2. Redistributions in binary form must reproduce the above copyright</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer in the</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *     documentation and/or other materials provided with the distribution.</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *  3. Neither the name of the copyright holder nor the</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *     names of its contributors may be used to endorse or promote products</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *     derived from this software without specific prior written permission.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> *  POSSIBILITY OF SUCH DAMAGE.</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#ifndef TIMER_HPP_</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#define TIMER_HPP_</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &lt;stddef.h&gt;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../dc/dbf/openthread-types_8h.html">openthread-types.h</a>&gt;</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../df/d84/tasklet_8hpp.html">common/tasklet.hpp</a>&gt;</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d2/d2d/alarm_8h.html">platform/alarm.h</a>&gt;</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="keyword">namespace </span><a class="code" href="../../d9/d00/namespaceThread.html">Thread</a> {</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="keyword">namespace </span>Ip6 { <span class="keyword">class </span>Ip6; }</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="keyword">class </span>Timer;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="../../df/d1f/classThread_1_1TimerScheduler.html">   64</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../df/d1f/classThread_1_1TimerScheduler.html">TimerScheduler</a></div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;{</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="../../d1/d40/classThread_1_1Timer.html">Timer</a>;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <a class="code" href="../../df/d1f/classThread_1_1TimerScheduler.html">TimerScheduler</a>(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="keywordtype">void</span> Add(<a class="code" href="../../d1/d40/classThread_1_1Timer.html">Timer</a> &amp;aTimer);</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <span class="keywordtype">void</span> Remove(<a class="code" href="../../d1/d40/classThread_1_1Timer.html">Timer</a> &amp;aTimer);</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <span class="keywordtype">bool</span> IsAdded(<span class="keyword">const</span> <a class="code" href="../../d1/d40/classThread_1_1Timer.html">Timer</a> &amp;aTimer);</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <span class="keywordtype">void</span> FireTimers(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <a class="code" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html">Ip6::Ip6</a> *GetIp6();</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="keywordtype">void</span> SetAlarm(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">bool</span> TimerCompare(<span class="keyword">const</span> <a class="code" href="../../d1/d40/classThread_1_1Timer.html">Timer</a> &amp;aTimerA, <span class="keyword">const</span> <a class="code" href="../../d1/d40/classThread_1_1Timer.html">Timer</a> &amp;aTimerB);</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <a class="code" href="../../d1/d40/classThread_1_1Timer.html">Timer</a> *mHead;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;};</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div><div class="line"><a name="l00138"></a><span class="lineno"><a class="line" href="../../d1/d40/classThread_1_1Timer.html">  138</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../d1/d40/classThread_1_1Timer.html">Timer</a></div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;{</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="../../df/d1f/classThread_1_1TimerScheduler.html">TimerScheduler</a>;</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00148"></a><span class="lineno"><a class="line" href="../../d1/d40/classThread_1_1Timer.html#a2fe8bf97d81d29df9bad88079bf66f2e">  148</a></span>&#160;    <span class="keyword">typedef</span> void (*Handler)(<span class="keywordtype">void</span> *aContext);</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00158"></a><span class="lineno"><a class="line" href="../../d1/d40/classThread_1_1Timer.html#afe38dac3e183645efd6e926cba7c6717">  158</a></span>&#160;    <a class="code" href="../../d1/d40/classThread_1_1Timer.html#afe38dac3e183645efd6e926cba7c6717">Timer</a>(<a class="code" href="../../df/d1f/classThread_1_1TimerScheduler.html">TimerScheduler</a> &amp;aScheduler, Handler aHandler, <span class="keywordtype">void</span> *aContext):</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        mScheduler(aScheduler),</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        mHandler(aHandler),</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        mContext(aContext),</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        mT0(0),</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        mDt(0),</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        mNext(NULL) {</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;    }</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;</div><div class="line"><a name="l00173"></a><span class="lineno"><a class="line" href="../../d1/d40/classThread_1_1Timer.html#a93beaa1e8a8b8692b1558fe5ae138406">  173</a></span>&#160;    uint32_t <a class="code" href="../../d1/d40/classThread_1_1Timer.html#a93beaa1e8a8b8692b1558fe5ae138406">Gett0</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mT0; }</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;</div><div class="line"><a name="l00181"></a><span class="lineno"><a class="line" href="../../d1/d40/classThread_1_1Timer.html#ab236dd1d1895c9590084097da119e78e">  181</a></span>&#160;    uint32_t <a class="code" href="../../d1/d40/classThread_1_1Timer.html#ab236dd1d1895c9590084097da119e78e">Getdt</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDt; }</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;</div><div class="line"><a name="l00189"></a><span class="lineno"><a class="line" href="../../d1/d40/classThread_1_1Timer.html#a8815311dffb2fff6b548b63bfc7d6dba">  189</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="../../d1/d40/classThread_1_1Timer.html#a8815311dffb2fff6b548b63bfc7d6dba">IsRunning</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mScheduler.IsAdded(*<span class="keyword">this</span>); }</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div><div class="line"><a name="l00196"></a><span class="lineno"><a class="line" href="../../d1/d40/classThread_1_1Timer.html#a475731e21b59be6b17b24f5b5e175f62">  196</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d1/d40/classThread_1_1Timer.html#a475731e21b59be6b17b24f5b5e175f62">Start</a>(uint32_t aDt) { StartAt(GetNow(), aDt); }</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;</div><div class="line"><a name="l00204"></a><span class="lineno"><a class="line" href="../../d1/d40/classThread_1_1Timer.html#a49ded72fbbf2588e1ddb545fa3f1f9f0">  204</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d1/d40/classThread_1_1Timer.html#a49ded72fbbf2588e1ddb545fa3f1f9f0">StartAt</a>(uint32_t aT0, uint32_t aDt) { mT0 = aT0; mDt = aDt; mScheduler.Add(*<span class="keyword">this</span>); }</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;</div><div class="line"><a name="l00210"></a><span class="lineno"><a class="line" href="../../d1/d40/classThread_1_1Timer.html#a9acdec1cdf4edf947c563d40871f2bc8">  210</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d1/d40/classThread_1_1Timer.html#a9acdec1cdf4edf947c563d40871f2bc8">Stop</a>(<span class="keywordtype">void</span>) { mScheduler.Remove(*<span class="keyword">this</span>); }</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;</div><div class="line"><a name="l00218"></a><span class="lineno"><a class="line" href="../../d1/d40/classThread_1_1Timer.html#a0596072dec177b5e2b494db19800267d">  218</a></span>&#160;    <span class="keyword">static</span> uint32_t <a class="code" href="../../d1/d40/classThread_1_1Timer.html#a0596072dec177b5e2b494db19800267d">GetNow</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> <a class="code" href="../../dd/db6/group__alarm.html#gaf8829e3591e03e29e136685fcdeb3300">otPlatAlarmGetNow</a>(); }</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;</div><div class="line"><a name="l00226"></a><span class="lineno"><a class="line" href="../../d1/d40/classThread_1_1Timer.html#a38c2681adb35b234d62b9848f89318b0">  226</a></span>&#160;    <span class="keyword">static</span> uint32_t <a class="code" href="../../d1/d40/classThread_1_1Timer.html#a38c2681adb35b234d62b9848f89318b0">SecToMsec</a>(uint32_t aSeconds) { <span class="keywordflow">return</span> aSeconds * 1000u; }</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;</div><div class="line"><a name="l00234"></a><span class="lineno"><a class="line" href="../../d1/d40/classThread_1_1Timer.html#a8d56b463dc5c9f2fa82764efe3a700c7">  234</a></span>&#160;    <span class="keyword">static</span> uint32_t <a class="code" href="../../d1/d40/classThread_1_1Timer.html#a8d56b463dc5c9f2fa82764efe3a700c7">MsecToSec</a>(uint32_t aMilliseconds) { <span class="keywordflow">return</span> aMilliseconds / 1000u; }</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;</div><div class="line"><a name="l00242"></a><span class="lineno"><a class="line" href="../../d1/d40/classThread_1_1Timer.html#a172d3d4acd2ee14b151f065be0ce50a9">  242</a></span>&#160;    <span class="keyword">static</span> uint32_t <a class="code" href="../../d1/d40/classThread_1_1Timer.html#a172d3d4acd2ee14b151f065be0ce50a9">HoursToMsec</a>(uint32_t aHours) { <span class="keywordflow">return</span> SecToMsec(aHours * 3600u); }</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;</div><div class="line"><a name="l00250"></a><span class="lineno"><a class="line" href="../../d1/d40/classThread_1_1Timer.html#a3096187b969de9537e7480231097620c">  250</a></span>&#160;    <span class="keyword">static</span> uint32_t <a class="code" href="../../d1/d40/classThread_1_1Timer.html#a3096187b969de9537e7480231097620c">MsecToHours</a>(uint32_t aMilliseconds) { <span class="keywordflow">return</span> MsecToSec(aMilliseconds / 3600u); }</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;    <span class="keywordtype">void</span> Fired(<span class="keywordtype">void</span>) { mHandler(mContext); }</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;    <a class="code" href="../../df/d1f/classThread_1_1TimerScheduler.html">TimerScheduler</a> &amp;mScheduler;</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;    Handler         mHandler;</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;    <span class="keywordtype">void</span>           *mContext;</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;    uint32_t        mT0;</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;    uint32_t        mDt;</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;    <a class="code" href="../../d1/d40/classThread_1_1Timer.html">Timer</a>          *mNext;</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;};</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;}  <span class="comment">// namespace Thread</span></div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;<span class="preprocessor">#endif  // TIMER_HPP_</span></div><div class="ttc" id="classThread_1_1Timer_html_a49ded72fbbf2588e1ddb545fa3f1f9f0"><div class="ttname"><a href="../../d1/d40/classThread_1_1Timer.html#a49ded72fbbf2588e1ddb545fa3f1f9f0">Thread::Timer::StartAt</a></div><div class="ttdeci">void StartAt(uint32_t aT0, uint32_t aDt)</div><div class="ttdoc">This method schedules the timer to fire at dt milliseconds from t0. </div><div class="ttdef"><b>Definition:</b> timer.hpp:204</div></div>
<div class="ttc" id="classThread_1_1Timer_html_a8d56b463dc5c9f2fa82764efe3a700c7"><div class="ttname"><a href="../../d1/d40/classThread_1_1Timer.html#a8d56b463dc5c9f2fa82764efe3a700c7">Thread::Timer::MsecToSec</a></div><div class="ttdeci">static uint32_t MsecToSec(uint32_t aMilliseconds)</div><div class="ttdoc">This static method returns the number of seconds given milliseconds. </div><div class="ttdef"><b>Definition:</b> timer.hpp:234</div></div>
<div class="ttc" id="classThread_1_1Timer_html_a475731e21b59be6b17b24f5b5e175f62"><div class="ttname"><a href="../../d1/d40/classThread_1_1Timer.html#a475731e21b59be6b17b24f5b5e175f62">Thread::Timer::Start</a></div><div class="ttdeci">void Start(uint32_t aDt)</div><div class="ttdoc">This method schedules the timer to fire a dt milliseconds from now. </div><div class="ttdef"><b>Definition:</b> timer.hpp:196</div></div>
<div class="ttc" id="classThread_1_1Timer_html_afe38dac3e183645efd6e926cba7c6717"><div class="ttname"><a href="../../d1/d40/classThread_1_1Timer.html#afe38dac3e183645efd6e926cba7c6717">Thread::Timer::Timer</a></div><div class="ttdeci">Timer(TimerScheduler &amp;aScheduler, Handler aHandler, void *aContext)</div><div class="ttdoc">This constructor creates a timer instance. </div><div class="ttdef"><b>Definition:</b> timer.hpp:158</div></div>
<div class="ttc" id="classThread_1_1Timer_html_a172d3d4acd2ee14b151f065be0ce50a9"><div class="ttname"><a href="../../d1/d40/classThread_1_1Timer.html#a172d3d4acd2ee14b151f065be0ce50a9">Thread::Timer::HoursToMsec</a></div><div class="ttdeci">static uint32_t HoursToMsec(uint32_t aHours)</div><div class="ttdoc">This static method returns the number of milliseconds given hours. </div><div class="ttdef"><b>Definition:</b> timer.hpp:242</div></div>
<div class="ttc" id="classThread_1_1Timer_html"><div class="ttname"><a href="../../d1/d40/classThread_1_1Timer.html">Thread::Timer</a></div><div class="ttdoc">This class implements a timer. </div><div class="ttdef"><b>Definition:</b> timer.hpp:138</div></div>
<div class="ttc" id="classThread_1_1TimerScheduler_html"><div class="ttname"><a href="../../df/d1f/classThread_1_1TimerScheduler.html">Thread::TimerScheduler</a></div><div class="ttdoc">This class implements the timer scheduler. </div><div class="ttdef"><b>Definition:</b> timer.hpp:64</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1Ip6_html"><div class="ttname"><a href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html">Thread::Ip6::Ip6</a></div><div class="ttdoc">This class implements the core IPv6 message processing. </div><div class="ttdef"><b>Definition:</b> ip6.hpp:96</div></div>
<div class="ttc" id="group__alarm_html_gaf8829e3591e03e29e136685fcdeb3300"><div class="ttname"><a href="../../dd/db6/group__alarm.html#gaf8829e3591e03e29e136685fcdeb3300">otPlatAlarmGetNow</a></div><div class="ttdeci">uint32_t otPlatAlarmGetNow(void)</div><div class="ttdoc">Get the current time. </div></div>
<div class="ttc" id="classThread_1_1Timer_html_a8815311dffb2fff6b548b63bfc7d6dba"><div class="ttname"><a href="../../d1/d40/classThread_1_1Timer.html#a8815311dffb2fff6b548b63bfc7d6dba">Thread::Timer::IsRunning</a></div><div class="ttdeci">bool IsRunning(void) const </div><div class="ttdoc">This method indicates whether or not the timer instance is running. </div><div class="ttdef"><b>Definition:</b> timer.hpp:189</div></div>
<div class="ttc" id="tasklet_8hpp_html"><div class="ttname"><a href="../../df/d84/tasklet_8hpp.html">tasklet.hpp</a></div><div class="ttdoc">This file includes definitions for tasklets and the tasklet scheduler. </div></div>
<div class="ttc" id="classThread_1_1Timer_html_a93beaa1e8a8b8692b1558fe5ae138406"><div class="ttname"><a href="../../d1/d40/classThread_1_1Timer.html#a93beaa1e8a8b8692b1558fe5ae138406">Thread::Timer::Gett0</a></div><div class="ttdeci">uint32_t Gett0(void) const </div><div class="ttdoc">This method returns the start time in milliseconds for the timer. </div><div class="ttdef"><b>Definition:</b> timer.hpp:173</div></div>
<div class="ttc" id="classThread_1_1Timer_html_a38c2681adb35b234d62b9848f89318b0"><div class="ttname"><a href="../../d1/d40/classThread_1_1Timer.html#a38c2681adb35b234d62b9848f89318b0">Thread::Timer::SecToMsec</a></div><div class="ttdeci">static uint32_t SecToMsec(uint32_t aSeconds)</div><div class="ttdoc">This static method returns the number of milliseconds given seconds. </div><div class="ttdef"><b>Definition:</b> timer.hpp:226</div></div>
<div class="ttc" id="alarm_8h_html"><div class="ttname"><a href="../../d2/d2d/alarm_8h.html">alarm.h</a></div><div class="ttdoc">This file includes the platform abstraction for the alarm service. </div></div>
<div class="ttc" id="classThread_1_1Timer_html_a9acdec1cdf4edf947c563d40871f2bc8"><div class="ttname"><a href="../../d1/d40/classThread_1_1Timer.html#a9acdec1cdf4edf947c563d40871f2bc8">Thread::Timer::Stop</a></div><div class="ttdeci">void Stop(void)</div><div class="ttdoc">This method stops the timer. </div><div class="ttdef"><b>Definition:</b> timer.hpp:210</div></div>
<div class="ttc" id="classThread_1_1Timer_html_ab236dd1d1895c9590084097da119e78e"><div class="ttname"><a href="../../d1/d40/classThread_1_1Timer.html#ab236dd1d1895c9590084097da119e78e">Thread::Timer::Getdt</a></div><div class="ttdeci">uint32_t Getdt(void) const </div><div class="ttdoc">This method returns the delta time in milliseconds for the timer. </div><div class="ttdef"><b>Definition:</b> timer.hpp:181</div></div>
<div class="ttc" id="openthread-types_8h_html"><div class="ttname"><a href="../../dc/dbf/openthread-types_8h.html">openthread-types.h</a></div><div class="ttdoc">This file defines the types and structures used in the OpenThread library API. </div></div>
<div class="ttc" id="classThread_1_1Timer_html_a3096187b969de9537e7480231097620c"><div class="ttname"><a href="../../d1/d40/classThread_1_1Timer.html#a3096187b969de9537e7480231097620c">Thread::Timer::MsecToHours</a></div><div class="ttdeci">static uint32_t MsecToHours(uint32_t aMilliseconds)</div><div class="ttdoc">This static method returns the number of hours given milliseconds. </div><div class="ttdef"><b>Definition:</b> timer.hpp:250</div></div>
<div class="ttc" id="classThread_1_1Timer_html_a0596072dec177b5e2b494db19800267d"><div class="ttname"><a href="../../d1/d40/classThread_1_1Timer.html#a0596072dec177b5e2b494db19800267d">Thread::Timer::GetNow</a></div><div class="ttdeci">static uint32_t GetNow(void)</div><div class="ttdoc">This static method returns the current time in milliseconds. </div><div class="ttdef"><b>Definition:</b> timer.hpp:218</div></div>
<div class="ttc" id="namespaceThread_html"><div class="ttname"><a href="../../d9/d00/namespaceThread.html">Thread</a></div><div class="ttdef"><b>Definition:</b> cli.cpp:61</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="../../dir_aebb8dcc11953d78e620bbef0b9e2183.html">core</a></li><li class="navelem"><a class="el" href="../../dir_34b4cee2b5900b653deb3438fc906cf4.html">common</a></li><li class="navelem"><a class="el" href="../../df/d05/timer_8hpp.html">timer.hpp</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:33 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
